package dev.ninjdai.werewolf.uhc;

import dev.ninjdai.werewolf.uhc.roles.Role;
import dev.ninjdai.werewolf.uhc.roles.Roles;
import dev.ninjdai.werewolf.uhc.teams.Team;
import dev.ninjdai.werewolf.uhc.teams.Teams;
import io.github.togar2.pvp.MinestomPvP;
import io.github.togar2.pvp.player.CombatPlayerImpl;
import lombok.Getter;
import net.minestom.server.entity.GameMode;
import net.minestom.server.network.packet.server.play.WorldBorderSizePacket;
import net.minestom.server.network.player.PlayerConnection;
import net.minestom.server.potion.Potion;
import net.minestom.server.potion.PotionEffect;
import net.minestom.server.timer.TaskSchedule;
import org.jetbrains.annotations.NotNull;

import java.util.Optional;
import java.util.UUID;

public class UHCPlayer extends CombatPlayerImpl {
    @Getter private boolean spectating;
    public UHCPlayer(@NotNull UUID uuid, @NotNull String username, @NotNull PlayerConnection playerConnection) {
        super(uuid, username, playerConnection);
    }

    public void setUHCTeam(Team team) {
        this.updateTag(Team.teamTag, (t) -> team.getId());
    }

    public Team getUHCTeam() {
        return Team.teamMap.getOrDefault(getTag(Team.teamTag), Teams.VILLAGERS.get());
    }

    public void setUHCRole(Role role) {
        this.updateTag(Role.roleTag, (r) -> role.getId());
    }

    public Role getUHCRole() {
        String teamId = getTag(Role.roleTag);
        return Role.roleMap.getOrDefault(teamId, Roles.VILLAGER.role);
    }

    public void toggleSpectating() {
        if (isSpectating()) {
            spectating = false;

            setGameMode(GameMode.SURVIVAL);
            setInvisible(false);
        } else {
            spectating = true;

            addEffect(new Potion(PotionEffect.BLINDNESS, (byte) 3, 100, (byte) 0));
            setGameMode(GameMode.SPECTATOR);
            setInvisible(true);
        }
    }
}
