package dev.ninjdai.werewolf.uhc.effects;

import net.minestom.server.entity.Player;

public abstract class Effect {
    /**
     * The effect's properties. See AbstractEffectProperty
     */
    EffectProperty effectProperty;
    /**
     * Function to run on effect start
     */
    public void onEffectStart(Player affectedPlayer){};

    /**
     * Function to run on effect end
     */
    public void onEffectEnd(Player affectedPlayer){};

    /**
     * Applies the effect to the affected Player
     */
    void applyEffect(Player player){
        effectProperty.potion.ifPresent(player::addEffect);
    }
}

