package dev.ninjdai.werewolf.uhc.events;

import dev.ninjdai.werewolf.uhc.UHCPlayer;
import dev.ninjdai.werewolf.uhc.roles.Role;
import dev.ninjdai.werewolf.uhc.roles.Roles;
import dev.ninjdai.werewolf.uhc.teams.Team;
import dev.ninjdai.werewolf.uhc.teams.Teams;
import dev.ninjdai.werewolf.uhc.teams.WinCondition;
import io.github.togar2.pvp.events.EntityPreDeathEvent;
import net.kyori.adventure.sound.Sound;
import net.kyori.adventure.text.Component;
import net.kyori.adventure.text.format.Style;
import net.kyori.adventure.text.format.TextColor;
import net.minestom.server.MinecraftServer;
import net.minestom.server.entity.GameMode;
import net.minestom.server.entity.Player;
import net.minestom.server.event.EventFilter;
import net.minestom.server.event.EventNode;
import net.minestom.server.event.trait.EntityEvent;
import net.minestom.server.sound.SoundEvent;
import org.jetbrains.annotations.NotNull;

import java.util.Set;
import java.util.stream.Collectors;
import java.util.stream.Stream;

public class UHCPlayerDeathEvent {
    public static void onPlayerDeath(EntityPreDeathEvent event) {
        UHCPlayer player = (UHCPlayer) event.getEntity();
        if(WinCondition.checkWin(event.getInstance())) {
            event.getInstance().playSound(Sound.sound().type(SoundEvent.ENTITY_ENDER_DRAGON_GROWL).source(Sound.Source.PLAYER).build());
            event.getInstance().sendMessage(Component.empty()
                    .append(Component.text("Team "))
                    .append(Component.text(WinCondition.winningTeam.getName(), TextColor.color(WinCondition.winningTeam.getColor())))
                    .append(Component.text(" wins !"))
            );
        }

        event.setCancelDeath(true);
        player.toggleSpectating();


        var timedPlayerDeath = new TimedPlayerDeath(player, event.getDamage(), 15);

        player.getUHCRole().onPlayerDeath(player, timedPlayerDeath);
    }

    public static void register() {
        EventNode<EntityEvent> playerNode = EventNode.type("player-listener", EventFilter.ENTITY);
        MinecraftServer.getGlobalEventHandler().addChild(playerNode);

        playerNode.addListener(EntityPreDeathEvent.class, event -> {
            if (event.getEntity() instanceof UHCPlayer) onPlayerDeath(event);
        });
    }
}
